extends "res://Actors/Enemies/Enemy.gd"

export var jump_power = 5000

onready var _floor_checker = get_node("FloorChecker")
onready var _sprite = get_node("Sprite")

var _jumping = false

func _ready():
	get_node("Detector").connect("area_enter", self, "_detector_area_enter")
	set_process(true)

func _process(delta):
	# Stay upright.
	if get_rot() != 0:
		set_rot(0)
	# Land from jumps.
	if _jumping == true and _floor_checker.is_overlapping():
		# For immediate physics feedback, since apply_impulse takes a sec.
		if Physics2DServer.body_get_state(self, Physics2DServer.BODY_STATE_LINEAR_VELOCITY).y >= 0:
			_jumping = false
			_sprite.set_frame(0)

func _detector_area_enter(area):
	if area.is_in_group("Player"):
		jump()

func jump():
	if _jumping == true:
		return
	_jumping = true
	_sprite.set_frame(1)
	# XXX set_sleeping(true) bizarrely fixes a bug(?) where the jump height is less if the player approaches from above.
	set_sleeping(true)
	apply_impulse(Vector2(0, 0), Vector2(0, -jump_power))
