extends Area2D

const Zombie = preload("res://Actors/Enemies/Graveyard/Zombie/Zombie.tscn")

export(int) var max_number_of_zombies = 3
export(float) var spawn_time = 5.0
export(float) var spawn_variance = 0.1

var left_edge = null
var right_edge = null
var y = null

var _timer = spawn_time
var zombies = []

func _ready():
	# Assume a RectangleShape2D.
	var shape = get_shape(0)
	var extents = shape.get_extents()
	var pos = get_global_pos()
	left_edge = pos.x - extents.x
	right_edge = pos.x + extents.x
	y = pos.y
	set_process(true)

func _process(delta):
	if zombies.size() < max_number_of_zombies:
		_timer = _timer - delta
	if _timer <= 0:
		_timer = spawn_time + (rand_range(-spawn_time, spawn_time) * spawn_variance)
		_spawn_zombie()

func _spawn_zombie():
	var pos = Vector2(rand_range(left_edge, right_edge), y)
	var zombie = Zombie.instance()
	zombie.spawner = self
	zombie.set_global_pos(pos)
	# Null-out some defaults.
	zombie.starting_state = null
	zombie.get_node("Hitbox").set_collision_mask_bit(0, false)
	zombie.get_node("Hitbox").set_layer_mask_bit(0, false)
	zombie.get_node("AnimationPlayer").play("Spawn")
	zombie.get_node("Sprites").set_scale(zombie.get_node("Sprites").get_scale() * Vector2(1, 0))
	get_node("..").add_child(zombie)
	zombies.append(zombie)
