extends "res://Actors/State.gd"

const ACCELERATION = 25
const MAX_SPEED = 100
const ZERO_VECTOR = Vector2(0, 0)

var _left_checker = null
var _right_checker = null
var _sprites = null
var _walk_right = true

func get_name():
	return "Walking"

func enter(parent):
	.enter(parent)
	_left_checker = parent.get_node("LeftChecker")
	_right_checker = parent.get_node("RightChecker")
	_sprites = parent.get_node("Sprites")
	if parent.get_global_pos().x > Global.get_player().get_global_pos().x:
		_flip_sprites()
		_walk_right = false

func _fixed_process(delta):
	parent.set_rot(0)
	if _walk_right == true:
		if not _right_checker.is_overlapping() or (parent.spawner != null and parent.get_global_pos().x > parent.spawner.right_edge):
			if not _left_checker.is_overlapping():
				return
			parent.set_linear_velocity(ZERO_VECTOR)
			_flip_sprites()
			_walk_right = false
			return
		if parent.get_linear_velocity().x < MAX_SPEED:
			parent.apply_impulse(ZERO_VECTOR, Vector2(ACCELERATION * delta, 0))
	else:
		if not _left_checker.is_overlapping() or (parent.spawner != null and parent.get_global_pos().x < parent.spawner.left_edge):
			if not _right_checker.is_overlapping():
				return
			parent.set_linear_velocity(ZERO_VECTOR)
			_flip_sprites()
			_walk_right = true
			return
		if parent.get_linear_velocity().x > -1 * MAX_SPEED:
			parent.apply_impulse(ZERO_VECTOR, Vector2(-ACCELERATION * delta, 0))

func _flip_sprites():
	var sprite_scale = _sprites.get_scale()
	_sprites.set_scale(sprite_scale * Vector2(-1, 1))
