extends Node

const COMESTIBLE = 0

const CATEGORIES = [COMESTIBLE]

var comestibles = []

func _ready():
	pass

# Add an Entry for the given Item to the appropriate category.
func add(item):
	if item.category == COMESTIBLE:
		_add_or_append(comestibles, item)
	else:
		print("Invalid Category: ", item.category)
		assert(false)

# Add or append the given item to the given list of entries.
func _add_or_append(entries, item):
	var entry_existed = false
	for entry in entries:
		if entry.name == item.name:
			entry.count = entry.count + 1
			entry_existed = true
			break
	if not entry_existed:
		entries.append(_item_to_entry(item))

# Return a new Entry describing the given Item.
func _item_to_entry(item):
	var entry = Entry.new()
	entry.name = item.name
	entry.description = item.description
	entry.path = item.get_filename()
	# Would be the case if any items didn't come directly from scene files.
	assert(entry.path != null)
	return entry

class Entry:
	var name = null
	var description = null
	var count = 1
	var path = null
