extends "res://Actors/Player/States/PlayerState.gd"

const Ducking = preload("res://Actors/Player/States/Ducking.gd")
const Floating = preload("res://Actors/Player/States/Floating.gd")
const Standing = preload("res://Actors/Player/States/Standing.gd")

const DURATION = 0.1 # s
const JUMP_HEIGHT_MULTIPLIER = 1.0
const Y_SPEED_STEP = 375

var _speed_mod = null
var _x_velocity = null
var _y_velocity = null

func get_name():
	return "Backflipping"

func enter(player):
	.enter(player)
	_x_velocity = player.horizontal_speed * player.walking_multiplier * player.running_multiplier * (-1 * player.direction)
	_y_velocity = player.jump_height * JUMP_HEIGHT_MULTIPLIER / DURATION
	_speed_mod = player.agility / 100.0

# Backflip until landing.
func _fixed_process(delta):
	# Land (or splash).
	if _y_velocity >= 0:
		if player.is_in_water():
			return Floating.new()
		if player.is_grounded():
			if Input.is_action_pressed("player_duck"):
				return Ducking.new()
			return Standing.new()
	_y_velocity = _y_velocity + ((Y_SPEED_STEP * _speed_mod * delta) / DURATION)
	player.move_by(Vector2(_x_velocity * delta, _y_velocity * delta), false)

# Backflipping is a form of dodging.
func hit_enemy(enemy):
	pass

# Prevent the animation from unwinding in a silly fashion.
func exit():
	player.animation_player.play("Backflipping", 0)
