extends "res://Actors/Player/States/PlayerState.gd"

const Falling = preload("res://Actors/Player/States/Falling.gd")

const CREST_HEIGHT_FRACTION = 0.25
const CREST_TIME = 0.05 # s
const JUMP_TIME = 0.45 # s

var _jump_time_remaining = JUMP_TIME

func get_name():
	return "DragonPunching"

# Very similar to Jumping.gd
func _fixed_process(delta):
	_jump_time_remaining = _jump_time_remaining - delta
	# Determine slice of motion based on jump_height and time fraction.
	var y_velocity = player.jump_height * (delta / JUMP_TIME)
	# Reduced percentage for slightly rounded transitions.
	if _jump_time_remaining <= 0:
		y_velocity = y_velocity * CREST_HEIGHT_FRACTION * ((CREST_TIME + _jump_time_remaining) / CREST_TIME)
	# If we're not rising, we're Falling.
	if y_velocity > 0:
		return Falling.new()
	# Only vertical movement while DragonPunching.
	player.move_by(Vector2(0, y_velocity))

# Go through enemies while DragonPunching.
func hit_enemy(enemy):
	pass

func exit():
	player.cancel_attack()
