extends "res://Actors/Player/States/PlayerState.gd"

const Ducking = preload("res://Actors/Player/States/Ducking.gd")
const Floating = preload("res://Actors/Player/States/Floating.gd")
const Standing = preload("res://Actors/Player/States/Standing.gd")

const DURATION = 0.5 # s
const JUMP_HEIGHT_MULTIPLIER = 0.75
const Y_SPEED_STEP = 375

var direction = 0

var _speed_mod = null
var _x_velocity = null
var _y_velocity = null

func get_name():
	return "Recoiling"

func enter(player):
	assert(direction != 0)
	.enter(player)
	_speed_mod = player.agility / 100.0
	_x_velocity = player.horizontal_speed * player.walking_multiplier * direction
	_y_velocity = player.jump_height * JUMP_HEIGHT_MULTIPLIER / DURATION
	player.cancel_attack()

# Backflip until landing.
func _fixed_process(delta):
	# Land.
	if _y_velocity >= 0:
		if player.is_in_water():
			return Floating.new()
		if player.is_grounded():
			if Input.is_action_pressed("player_duck"):
				return Ducking.new()
			return Standing.new()
	_y_velocity = _y_velocity + ((Y_SPEED_STEP * _speed_mod * delta) / DURATION)
	player.move_by(Vector2(_x_velocity * delta, _y_velocity * delta), false)

# Don't get hit while recoiling.
func hit_enemy(enemy):
	pass
