extends "res://Actors/Player/States/PlayerState.gd"

const Backflipping = preload("res://Actors/Player/States/Backflipping.gd")
const Dodging = preload("res://Actors/Player/States/Dodging.gd")
const Ducking = preload("res://Actors/Player/States/Ducking.gd")
const Falling = preload("res://Actors/Player/States/Falling.gd")
const Jumping = preload("res://Actors/Player/States/Jumping.gd")
const Walking = preload("res://Actors/Player/States/Walking.gd")

const ZERO_VECTOR = Vector2(0, 0)

func get_name():
	return "Standing"

func enter(player):
	.enter(player)
	# Reset double-jumps and dodges upon landing.
	player.has_dodge = player.can_dodge
	player.has_extra_jump = player.can_double_jump

func _input(event):
	if player.should_jump(event) and not player.is_attacking():
		player.get_tree().set_input_as_handled()
		# Backflip.
		if Input.is_action_pressed("player_up"):
			return Backflipping.new()
		# Regular Jump.
		return Jumping.new()
	# Dodging.
	if (event.type == InputEvent.KEY or event.type == InputEvent.JOYSTICK_BUTTON) and event.is_pressed() and not event.is_echo():
		if player.has_dodge:
			if event.is_action("player_dodge_directional"):
				player.get_tree().set_input_as_handled()
				return Dodging.new()
			if event.is_action("player_dodge"):
				player.get_tree().set_input_as_handled()
				var dodging = Dodging.new()
				dodging.dodge_backward = true
				return dodging

func _fixed_process(delta):
	player.last_movement_vector = ZERO_VECTOR
	if player.is_grounded() == false:
		return Falling.new()
	if Input.is_action_pressed("player_duck"): # or player.is_roof_blocked():
		return Ducking.new()
	if player.get_horizontal_movement() != 0 and not player.is_attacking():
		return Walking.new()
