extends "res://Actors/Player/States/PlayerState.gd"

const Backflipping = preload("res://Actors/Player/States/Backflipping.gd")
const Dodging = preload("res://Actors/Player/States/Dodging.gd")
const Ducking = preload("res://Actors/Player/States/Ducking.gd")
const Falling = preload("res://Actors/Player/States/Falling.gd")
const Jumping = preload("res://Actors/Player/States/Jumping.gd")
const Standing = preload("res://Actors/Player/States/Standing.gd")

func get_name():
	return "Walking"

func _input(event):
	if player.should_jump(event):
		player.get_tree().set_input_as_handled()
		# Backflip.
		if Input.is_action_pressed("player_up"):
			return Backflipping.new()
		# Regular Jump.
		return Jumping.new()
	# Dodging.
	if (event.type == InputEvent.KEY or event.type == InputEvent.JOYSTICK_BUTTON) and event.is_pressed() and not event.is_echo():
		if player.has_dodge:
			if event.is_action("player_dodge_directional"):
				player.get_tree().set_input_as_handled()
				return Dodging.new()
			if event.is_action("player_dodge"):
				player.get_tree().set_input_as_handled()
				var dodging = Dodging.new()
				dodging.dodge_backward = true
				return dodging

func _fixed_process(delta):
	var y_velocity = 0
	var x_velocity = player.get_horizontal_movement() * delta
	# Stop walking if the player falls.
	if player.is_grounded() == false:
		# Unless it can be adjusted with a quick downward impulse.
		if player.should_stick_to_ground():
			y_velocity = abs(x_velocity)
		else:
			return Falling.new()
	if Input.is_action_pressed("player_duck"):
		return Ducking.new()
	# If they're not moving, they're standing.
	if x_velocity == 0 or player.is_attacking():
		return Standing.new()
	player.move_by(Vector2(x_velocity, y_velocity))
