extends "res://Actors/Substate.gd"

# Adjust the player so that they stay relative to a moving platform.

var platform = null setget _set_platform, _get_platform # To be set before state is attached.

var _last_pos = null

func get_name():
	"PlatformMoving"

# Track the initial position of the just-set (or switched) platform.
func _set_platform(new_platform):
	if platform != null and platform.get_ref() == new_platform:
		return
	platform = weakref(new_platform)
	_last_pos = new_platform.get_pos()

# Outsiders don't need to know this is a weakref.
func _get_platform():
	if platform == null:
		return null
	return platform.get_ref()

# Under certain states, expire. Otherwise, move along with the platform.
func _fixed_process(delta):
	# Stop following if we shouldn't stick.
	if platform.get_ref() == null or not parent.should_stick_to_platform():
		expire()
		return
	var pos = platform.get_ref().get_pos()
	var delta = pos - _last_pos
	parent.set_pos(parent.get_pos() + delta)
	_last_pos = pos
