extends "res://Actors/Player/Weapons/Weapon.gd"

onready var direction = player.direction
onready var speed = 500 * (player.agility / 100.0)

var lifetime = 3 # s

func _ready():
	if direction == -1:
		get_node("Sprite").set_flip_h(true)
	set_process(true)
	set_fixed_process(true)

# Eventually expire.
func _process(delta):
	lifetime = lifetime - delta
	if lifetime < 0:
		get_node("AnimationPlayer").play("FadeOut")
		set_process(false)

# Fly in the player's direction.
func _fixed_process(delta):
	var pos = get_pos()
	pos.x = pos.x + (direction * speed * delta)
	set_pos(pos)

# Fireball only hits one thing.
func get_damage():
	deactivate()
	queue_free()
	return .get_damage()
