extends "res://Actors/DamageDealer.gd"

const DAMAGE_DIVISOR = 100.0

export(String) var name
export(float) var damage_mod = 1.0
export(bool) var immediately_active = false

onready var player = Global.get_player()

# TODO: 3x sound effects per damage type per hit: weak, normal, super-effective.

func _ready():
	if immediately_active:
		activate()

# Signal that the weapon should do damage to enemies.
func activate():
	if not is_in_group("DamagesEnemies"):
		add_to_group("DamagesEnemies")
		# Signal to any enemies we'd entered before activating.
		for area in get_overlapping_areas():
			if area.is_in_group("Enemy"):
				area.get_node("..").take_damage(self)

# Signal that the weapon should not do damage to enemies.
func deactivate():
	remove_from_group("DamagesEnemies")

# Do damage based on inherent damage, mod, and player.strength.
func get_damage():
	var damage = self.damage + round(player.strength * damage_mod / DAMAGE_DIVISOR)
	# Do at least one damage if we're trying to inflict positive pain.
	if damage == 0 and damage_mod > 0:
		damage = 1
	return damage

# Return the physics impact that should be applied to the target.
func get_impact():
	return player.strength * impact

# Return the type(s) associated with this source of damage.
func get_types():
	return damage_types
