# Interface for independent / concurrent States.
var parent = null

# Return the unique string name of the substate. Must be overridden.
func get_name():
	assert(false)

# Attach this substate to the given parent object.
func attach(parent):
	assert(self.parent == null)
	self.parent = parent
	parent.substates.append(self)

# Handle input events. Do not consume them (they'll still be seen by each other and State).
func _input(event):
	pass

# Update physics processing.
func _fixed_process(delta):
	pass

# Update regular processing.
func _process(delta):
	pass

# Handle exit events and remove self from parent substates.
func expire():
	parent.substates.erase(self)
