# Class tracking an object which may be instantiated every so often.

var path = null
var rolls = 0
var rate = null

# Increase the number of rolls attempted.
# The likelihood of an object spawning is then that number divided by the rate.
# When an object spawns, the rolls counter is reset.
func roll():
	rolls = rolls + 1
	var lucky_number = randf()
	var cutoff = rolls / float(rate)
	if lucky_number <= cutoff:
		rolls = 0
		return load(path).instance()
	return null

# Return a new Drop with the given path and rate.
static func instance(path, rate):
	var drop = new()
	drop.path = path
	drop.rate = rate
	return drop
