extends Position2D

export(int, FLAGS, "Left", "Top", "Right", "Bottom") var margins = 0

# Update the parent level's camera margins based on our position.
func _ready():
	assert(margins != 0)
	# Can't use Global.get_level() since this is called while the new level is being added to the scene tree.
	var level = get_node("..")
	while level != null:
		if level.is_in_group("Level"):
			break
		level = level.get_node("..")
	assert(level != null)
	var pos = get_global_pos()
	if margins & 1:
		level.set("camera_margin_left", pos.x)
	if margins & 2:
		level.set("camera_margin_top", pos.y)
	if margins & 4:
		level.set("camera_margin_right", pos.x)
	if margins & 8:
		level.set("camera_margin_bottom", pos.y)
