# Fixed-size area that represents a mappable segment the player can enter.
extends Area2D

const Colors = preload("res://Constants/Colors.gd")

export(Vector2) var coordinates = null
export(int, "Regular", "Save") var room_type = 0
export(int, FLAGS, "East", "North", "West", "South") var walls = 0
export(int, FLAGS, "East", "North", "West", "South") var doors = 0

var color = null

func _ready():
	assert(coordinates != null)
	assert(room_type != null)
	# Make sure we didn't set both a wall and a door on the same face.
	assert(not(walls & Map.EAST and doors & Map.EAST))
	assert(not(walls & Map.NORTH and doors & Map.NORTH))
	assert(not(walls & Map.WEST and doors & Map.WEST))
	assert(not(walls & Map.SOUTH and doors & Map.SOUTH))
	_determine_color()
	connect("body_enter", self, "_on_body_enter")

func _on_body_enter(body):
	if body == Global.get_player():
		Map.explore(self)

func _determine_color():
	if room_type == 0:
		color = Map.REGULAR
	elif room_type == 1:
		color = Map.SAVE
	else:
		assert(false)
