extends StaticBody2D

const FileUtil = preload("res://Util/FileUtil.gd")

const BONE_CHANCE = 0.1

# Sometimes have a bone somewhere.
func _ready():
	if randf() <= BONE_CHANCE:
		_spawn_bone()

# Grab a random Skeleton sprite and place it somewhere.
func _spawn_bone():
	var files = FileUtil.find_files_of_type("res://Actors/Enemies/Graveyard/Skeleton", false, "png")
	if files.size() == 0:
		return
	var sprite = Sprite.new()
	var texture = ImageTexture.new()
	texture.load(files[randi() % files.size()])
	sprite.set_texture(texture)
	sprite.set_scale(Vector2(1, 1) * ((randf() / 4.0) + 0.25))
	sprite.set_pos(Vector2(rand_range(-128, 128), rand_range(-128, 128)))
	sprite.set_rot(randf() * 2 * PI)
	add_child(sprite)
