extends RigidBody2D

var lifetime = 7.5 # s

var _connected = false
var _half_life = null
var _player = null
var _timer = 0

func _ready():
	_half_life = lifetime / 2.0
	_player = get_node("../Player")
	_player.ignore_collisions_with(self)
	set_process(true)

func _process(delta):
	_timer = _timer + delta
	if _timer >= lifetime:
		queue_free()
	if _timer > _half_life:
		set_opacity(1 - ((_timer - _half_life) / _half_life))
	if not _connected and get_linear_velocity().y >= -2:
		get_node("Area2D").connect("body_enter", self, "_on_body_enter")
		_connected = true

# Trivially get collected.
func _on_body_enter(body):
	if body == _player:
		queue_free()
