extends Area2D

const Coin = preload("res://Misc/PiggyBank/Coin.tscn")

func _ready():
	connect("area_enter", self, "_on_area_enter")

# Pop if the right thing hits us.
func _on_area_enter(area):
	# TODO: Better mechanism for damage.
	if area.get_name() == "Hitbox":
		var player = area.get_node("..")
		var state_name = player.state.get_name()
		if state_name == "SlideKicking" or state_name == "DiveKicking":
			_pop(round(player.strength / 100.0))
	elif area.get_name() == "Weapon":
		_pop(area.get_damage())

# Explode into money!
func _pop(amount):
	for i in range(amount):
		var coin = Coin.instance()
		coin.set_global_pos(get_global_pos())
		coin.set_rot(rand_range(0, 360))
		coin.set_angular_velocity(rand_range(0, PI))
		var angle = rand_range(-PI / 8, PI / 8) + (PI / 2)
		var speed = rand_range(10, 25) * amount
		coin.set_linear_velocity(Vector2(speed * cos(angle), -speed * sin(angle)))
		get_node("..").add_child(coin)
