# https://godotengine.org/qa/9351/accept-inputevents-so-itemlist-does-not-handle-them
extends ItemList

func _ready():
	set_process_input(true)

# Wrap around from the top to the bottom and vice versa.
func _input(event):
	if not has_focus():
		return
	var first = 0
	var last = get_item_count() - 1
	if (event.type == InputEvent.KEY or event.type == InputEvent.JOYSTICK_BUTTON) and event.is_pressed() and not event.is_echo():
		if event.is_action("ui_up"):
			if is_selected(first):
				call_deferred("_self_select", last)
		if event.is_action("ui_down"):
			if is_selected(last):
				call_deferred("_self_select", first)

func _self_select(index):
	get_tree().set_input_as_handled()
	select(index)
	emit_signal("item_selected", index)
