extends "res://UI/Popup.gd"

onready var _map = Map.get_map()

const MOVE_SPEED = 50
const ZOOM_SCALE = 1.1

func _ready():
	# Center the map on the player.
	set_pos(get_viewport().get_rect().size / 2.0)
	if Map.player_coordinates != null:
		_map.set_pos(-(Map.player_coordinates * Map.square_size))
	set_scale(Map.map_scale)
	add_child(_map)
	set_process(true)

func _process(delta):
	# TODO Joystick Motion
	if Input.is_action_pressed("ui_left"):
		set_pos(get_pos() - Vector2(-MOVE_SPEED * delta * get_scale().x, 0))
	elif Input.is_action_pressed("ui_right"):
		set_pos(get_pos() - Vector2(MOVE_SPEED * delta * get_scale().x, 0))
	if Input.is_action_pressed("ui_up"):
		set_pos(get_pos() - Vector2(0, -MOVE_SPEED * delta * get_scale().y))
	elif Input.is_action_pressed("ui_down"):
		set_pos(get_pos() - Vector2(0, MOVE_SPEED * delta * get_scale().y))

func _input(event):
	if (event.type == InputEvent.KEY or event.type == InputEvent.JOYSTICK_BUTTON) and event.is_pressed() and not event.is_echo():
		# Pressing Tab again closes us.
		if event.is_action("ui_focus_next"):
			get_tree().set_input_as_handled()
			queue_free()
	if event.type == InputEvent.MOUSE_BUTTON and event.is_pressed() and not event.is_echo():
		if event.button_index == BUTTON_WHEEL_UP:
			get_tree().set_input_as_handled()
			set_scale(get_scale() * ZOOM_SCALE)
		if event.button_index == BUTTON_WHEEL_DOWN:
			get_tree().set_input_as_handled()
			set_scale(get_scale() / ZOOM_SCALE)

# Don't let the cached map get queue_freed.
func queue_free():
	Map.map_scale = get_scale()
	remove_child(_map)
	.queue_free()
