extends Node

var _parent = null

# Pause and make a note of the previous popup.
# Assumes new popups are immediate children of existing ones.
func _enter_tree():
	print("Popup In: ", get_name())
	set_pause_mode(PAUSE_MODE_PROCESS)
	get_tree().set_pause(true)
	if get_node("..") extends load("res://UI/Popup.gd"):
		_parent = get_node("..")
		_parent.set_pause_mode(PAUSE_MODE_STOP)
	set_process_input(true)

# By default, escape closes popups.
func _input(event):
	if (event.type == InputEvent.KEY or event.type == InputEvent.JOYSTICK_BUTTON) and event.is_pressed() and not event.is_echo():
		if event.is_action("ui_cancel"):
			get_tree().set_input_as_handled()
			queue_free()

func queue_free():
	# Unpause if we were the last popup.
	if _parent == null:
		get_tree().set_pause(false)
	else:
		# Otherwise allow our parent to resume processing.
		_parent.set_pause_mode(PAUSE_MODE_PROCESS)
	.queue_free()
