# Helper methods having to do with files and directories.

# Navigate through the given path, optionally recursing, and return all files,
# optionally only keeping those whose extension match the given filter.
static func find_files_of_type(path, recurse=false, filter=null):
	var results = []
	var directory = Directory.new()
	if directory.open(path) != OK:
		printerr("Could not open ", path)
		return results
	directory.list_dir_begin()
	if directory.list_dir_begin() == true:
		printerr("Could not list files from ", path)
		return results
	while true:
		var file = directory.get_next()
		if file == "":
			break
		if file == "." or file == "..":
			continue
		file = directory.get_current_dir() + "/" + file
		if directory.current_is_dir():
			for result in find_files_of_type(file, recurse, filter):
				results.append(result)
		else:
			if filter == null or file.extension().to_lower() == filter.to_lower():
				results.append(file)
	directory.list_dir_end()
	return results
